%smoothing_restoration2

load_image
   
Par=input('spline order--?');
deci=2;
lev=log2(deci);
ToX=.000000001;
range_rho1=10000000;%input('range_rho1; 111-former; ?')
% if range_rho1~=111
    range_rho=[0 range_rho1];
% end

y=bloch;
[M,~]=size(bloch);
st1=input('noise std; 0--no noise(interpolation);111-former; ?')
if st1~=111
    st=st1;
    nois=st*randn(M);
end


figure;
subplot(2,2,1)
D=(1:deci:M);
noi=nois(D,D);
x=y(D,D)+noi;
ee=sum(noi(:).^2);
rho=defroPSm(Par,x,ee,range_rho,ToX);

s=smooth_spline2DPt(x,2,Par,lev,2,Par,lev,rho);

aj(x);

title(['\fontsize{20}Sampl=1:' int2str(deci) ', STD=' num2str(st)])
set(gca,'Fontsize',20)
subplot(2,2,2)
[PSNR, mablod]=psnB(y,s);

aj(s)
title(['\fontsize{20}Spl. order: '  int2str(Par) ', PSNR=' num2str(PSNR,4 ) ', \rho=' num2str(rho,4) ])
set(gca,'Fontsize',20)

deci=2*deci;
lev=log2(deci);
subplot(2,2,3)
D=(1:deci:M);
noi=nois(D,D);
x=y(D,D)+noi;
ee=sum(noi(:).^2);
rho=defroPSm(Par,x,ee,range_rho,ToX);

s=smooth_spline2DPt(x,2,Par,lev,2,Par,lev,rho);
aj(x);

title(['\fontsize{20}Sampl=1:' int2str(deci) ', STD=' num2str(st)])
set(gca,'Fontsize',20)
subplot(2,2,4)
[PSNR, mablod]=psnB(y,s);

aj(s)
title(['\fontsize{20}Spl. order: '  int2str(Par) ', PSNR=' num2str(PSNR,4 ) ', \rho=' num2str(rho,2) ])
set(gca,'Fontsize',20)

